define([
        "dojo/_base/declare",
        "./ExtendedStore.js"
], function (
    declare,
    ExtendedStore
) {

return declare([ExtendedStore], {
    _useQueryEngine: true,
    queryCallback: function(remoteQuery, remoteOptions) {
        // function(remoteQuery, remoteOptions, resultQuery, resultOptions)
        this.inherited(arguments);
        delete remoteOptions["sort"];
        delete remoteOptions["start"];
        delete remoteOptions["count"];
    },
    itemsCallback: function(items, query, options) {
        if (this.customColumns != null) {
            for (var key in this.customColumns) {
                if(this.customColumns.hasOwnProperty(key)){
                    var column = this.customColumns[key];
                    if ("sort" in column && "sort" in options && options.sort !== null && options.sort.length > 0 && options.sort[0].attribute == key) {
                        delete options["sort"];
                    }
                }
            }
        }
        return this.inherited(arguments);
    }
});

});