define(["dojo/when", "./displayError.js"],
	function (when, displayError) {

		var notifyOk = function(blockId, successCallback) {
			document.body.style.cursor = 'inherit';
			if (successCallback) {
				successCallback(blockId);
			}
		};

		var notifyError = function (err, blockId, errorCallback) {
			document.body.style.cursor = 'inherit';

			if (errorCallback) {
				errorCallback(blockId, err);
			} else {
				displayError(err);
			}
		};

		var deleteBlock = function (block, numbers, store, successCallback, errorCallback) {
			document.body.style.cursor = 'wait';
			var blockId = block.aps.id;

			console.log("I'm trying to delete blocks instance with id = [" + blockId + "]");

			var numbersCount = numbers.length;
			var errors = [];

			var removeBlock = function () {
			    when(store.remove(blockId),
					function () {
					    console.log("Successful removed blocks instance with id = [" + blockId + "]");

					    notifyOk(blockId, successCallback);
					},
					function (err) {
					    notifyError(err, blockId, errorCallback);
					}
				);
			};

			var onNumberDeleted = function() {
				if (--numbersCount === 0) {
					if (errors.length === 0) {
						removeBlock();
					} else {
						notifyError(errors, blockId, errorCallback);
					}
				}
			};

			if (numbers.length === 0) {
				removeBlock();
			} else {
				for (var i=0; i<numbers.length; i++) {
					when(store.remove(numbers[i].aps.id),
						function() {
							onNumberDeleted();
						},
						function(err) {
							errors.push(err);
							onNumberDeleted();
						}
					);
				}
			}
	};

	return deleteBlock;

});
