define([
        "aps/i18n",
        "dijit/registry",
		"dojo/when",
		"./displayError.js"
], function(
    _,
    registry,
    when,
		displayError
) {
		function deleteGridRow(pluralName, store, grid, list){
			if (list.length === 0){
				var selectionArray = grid.get("selectionArray");
				selectionArray.all = false;
				selectionArray.length = 0;
				grid.set("store", store);
				document.body.style.cursor = 'inherit';
				return;
			}

			var itemId = list.splice(0, 1)[0];
			console.log("I'm trying to delete " + pluralName + " instance with id = [" + itemId + "]");
			when(store.remove(itemId),
				function() {
					console.log("Successful removed " + pluralName + " instance with id = [" + itemId + "]");

					deleteGridRow(pluralName, store, grid, list);
				},
				function(err) {
					list.push(itemId);

					var selectionArray = grid.get("selectionArray");
					selectionArray.all = false;
					selectionArray.length = 0;
					for (var i=0; i<list.length; i++) {
						selectionArray.push(list[i]);
					}

					document.body.style.cursor = 'inherit';
					displayError(err);
				});
		}

		var deleteGridRows = function (pluralName, store, gridId) {
		    if (!confirm(_("Are you sure you want to delete selected __objectName__?", { objectName: pluralName }))) return;

		    document.body.style.cursor = 'wait';

		    var page = registry.byId("pageContainer"),
				messages = page.get("messageList"),
				grid = registry.byId(typeof gridId === "undefined" ? "grid" : gridId),
				sel = grid.get("selectionArray");

		    messages.removeAll();

		    deleteGridRow(pluralName, store, grid, sel.slice(0));
		};

		return deleteGridRows;
	}
);