define([
    "dijit/registry",
    "aps/i18n",
    "aps/Message",
    "dojo/json"
], function (
    registry,
    _,
    Message,
    json
) {
        var pageUnload = false;
        window.onbeforeunload = function() {
            pageUnload = true;
        };


        var displayError = function (value) {
            if (pageUnload) {
                return;
            }

            aps.apsc.cancelProcessing();

            var page = registry.byId("pageContainer"), messages = page.get("messageList");
            messages.removeAll();

            var errors = value instanceof Array ? value : [value];
            var messageCounts = {};
            var message;
            for (var i=0; i<errors.length; i++) {
                var err = errors[i];
                if (typeof err == 'string' || err instanceof String){
                    message = err;
                }else{
                    var errData = {};
                    try {
                        errData = json.parse(err.response.text);
                    } catch (e) { }
                    message = "parametrizedMessage" in errData && errData.parametrizedMessage && "msgParams" in errData && errData.msgParams.length > 0 ? _(errData.parametrizedMessage, errData.msgParams) : errData.message ? (!("status" in err) || err.status === null ? "" : "[" + err.status + "] ") + _(errData.message.replace("REST Application returns error code=500: ", "")) : err;
                }
                messageCounts[message] = message in messageCounts ? messageCounts[message] + 1 : 1;
            }

            for (message in messageCounts) {
                if(messageCounts.hasOwnProperty(message)){
                    messages.addChild(new Message({ description: message.replace(/\n/gm, '<br/>') + (messageCounts[message] > 1 ? (" (" + messageCounts[message] + " occurences)") : ""), type: "error" }));
                }
            }
        };
        return displayError;
    }
);

