define(["aps/ResourceStore", "dojo/Deferred", "dojo/_base/lang" ], function (Store, Deferred, lang) {
    "use strict";
    return function (orgnizationId) {
        var deferredResult = new Deferred();

        if (typeof orgnizationId === "undefined") {
            if (aps.context.vars.organization) {
                orgnizationId = aps.context.vars.organization.aps.id;
            }
        }
        var lyncIntegrationQuery = new Store({ target: "/aps/2/resources/" + orgnizationId + "/lyncIntegration/" }).query();
        var organizationProfileQuery = new Store({ target: "/aps/2/resources/" + orgnizationId + "/organizationProfile/" }).query();
        lyncIntegrationQuery.then(function(lyncIntegrations) {
            var lyncIntegration = lyncIntegrations[0];
            organizationProfileQuery.then(function(organizationProfiles) {
                if (organizationProfiles.length > 0) {
                    deferredResult.resolve(lang.mixin(lyncIntegration, organizationProfiles[0]));
                } else {
                    deferredResult.resolve(lyncIntegration);
                }
            }, function(err) {
                deferredResult.reject(err);
            });
        }, function(err) {
            deferredResult.reject(err);
        });

        return deferredResult;
    };
});