define(["aps/Memory", "aps/ResourceStore", "dojo/Deferred", "./getSubscriptionResources.js"], function (Memory, Store, Deferred, getSubscriptionResources) {
    return function (orgnizationId, apsType, minAvailableLimit) {
        if (!minAvailableLimit) {
            minAvailableLimit = 0;
        }
        var deferredResult = new Deferred();

        var getSubsResources = getSubscriptionResources(orgnizationId, [apsType]);
        var requestResourceInstances = new Store({
            target: "/aps/2/resources/",
            apsType: apsType
        }).query();
        requestResourceInstances.then(function (resourceInstances) {
            resourceInstances = new Memory({ data: resourceInstances, idProperty: "aps.id" });
            getSubsResources.then(function (subscriptionResources) {
                var result = [];
                subscriptionResources = subscriptionResources[apsType];
                if (minAvailableLimit === 0 || subscriptionResources.isAvailable) {
                    var processItem = function(subscriptionResource) {
                        if (minAvailableLimit === 0 || subscriptionResource.isAvailable) {
                            result.push({
                                aps: { id: subscriptionResource.apsId },
                                resource: subscriptionResource,
                                service: resourceInstances.get(subscriptionResource.apsId)
                            });
                        }
                    };

                    subscriptionResources.forEach(processItem);
                }

                deferredResult.resolve(result);
            }, function(err) {
                deferredResult.reject(err);
            });
        }, function(err) {
            deferredResult.reject(err);
        });

        return deferredResult;
    };
});