
    require([
            "aps/parser",
            "dojo/when",
            "dojo/json",
            "dijit/registry",
            "dojox/mvc/StatefulArray",
            "aps/ResourceStore",
            "aps/Grid",
            "aps/Toolbar",
            "aps/Container",
            "aps/Button",
            "./displayError.js",
            "dojo/text!./newPhoneNumberProvider.json",
            "dojo/text!./newPhoneNumberBlockType1.json",
            "dojo/text!./newPhoneNumberBlockType2.json",
            "dojo/text!./newPhoneNumberBlockType3.json",
            "aps/ready!"
        ], function(
            parser,
            when,
            json,
            registry,
            StatefulArray,
            Store,
            Grid,
            Toolbar,
            Container,
            Button,
            displayError,
            newPhoneNumberProvider,
            newPhoneNumberBlockType1,
            newPhoneNumberBlockType2,
            newPhoneNumberBlockType3
        ) {
            console.log(aps.context);

            function checkBlockTypes(providerId) {
                var blockTypesStore = new Store({
                    apsType: "http://www.parallels.com/LyncHPv2/phoneNumberBlockType/1.0",
                    target: "/aps/2/resources/" + providerId + "/blockTypes"
                });

                blockTypesStore.query().then(function(items){
                    console.log(items);

                    if (items.length === 0) {
                        when(blockTypesStore.put(json.parse(newPhoneNumberBlockType1)),
                            function(data) {
                                console.log(data);

                                when(blockTypesStore.put(json.parse(newPhoneNumberBlockType2)),
                                    function(data) {
                                        console.log(data);

                                        when(blockTypesStore.put(json.parse(newPhoneNumberBlockType3)),
                                            function(data) {
                                                console.log(data);

                                                document.body.style.cursor = 'inherit';
                                                alert("Phone Number Provider successfully created!");
                                            },
                                            function(err) {
                                                alert(err);
                                            }
                                        );
                                    },
                                    function(err) {
                                        alert(err);
                                    }
                                );
                            },
                            function(err) {
                                alert(err);
                            }
                        );
                    } else {
                        document.body.style.cursor = 'inherit';
                    }
                });
            }

            var providersStore = new Store({
                apsType: "http://www.parallels.com/LyncHPv2/phoneNumberProvider/1.3",
                target: "/aps/2/resources/" + aps.context.vars.globals.aps.id + "/phoneNumberProviders"
            });

            document.body.style.cursor = 'wait';

            providersStore.query().then(function(providers){
                console.log(providers);

                if (providers.length < 1) {
                    newPhoneNumberProvider = json.parse(newPhoneNumberProvider);

                    when(providersStore.put(newPhoneNumberProvider),
                        function(data) {
                            console.log(data);
                            checkBlockTypes(data.aps.id);
                        },
                        function(err) {
                            alert(err);
                        }
                    );
                } else {
                    checkBlockTypes(providers[0].aps.id);
                }
            });
        }
    );