define(["./rql/parser.js", "dojo/_base/array", "dojo/has"], function(exports, arr, has){

/*	if (!Array.prototype.reduce) {		// Isn't implemented on server side
		Array.prototype.reduce = function reduce(accumlator){
			var i, l = this.length, curr;

			if (typeof accumlator !== "function") {// ES5 : "If IsCallable(callbackfn) is false, throw a TypeError exception."
				throw new TypeError("First argument is not callable");
			}

			if ((l == 0 || l === null) && (arguments.length <= 1)) { // == on purpose to test 0 and false.
				throw new TypeError("Array length is 0 and no second argument");
			}

			if (arguments.length <= 1) {
				curr = this[0]; // Increase i to start searching the secondly defined element in the array
				i = 1; // start accumulating at the second element
			} else {
				curr = arguments[1];
			}

			for (i = i || 0 ; i < l ; ++i) {
				if (i in this) {
					curr = accumlator.call(undefined, curr, this[i], i, this);
				}
			}

			return curr;
		};
	}	*/

	var ie = has("ie");

	var parseQuery = exports.parseQuery,
		stringify = JSON.stringify || function(str){
		return '"' + str.replace(/"/g, "\\\"") + '"';
	};

	function escape(s){
		return s.replace(/[-\/\\^$*+?.()|[\]{}]/g, '\\$&');
	}

	function likeToString(param){
		if(!param) return "false;";

		var start	 = param[0] == '*',
			end		 = param[param.length-1] == '*';

		if(start)	param = param.slice(1);
		if(end)		param = param.slice(0, param.length-1);

		var stars = param.split('*');
		if(stars.length > 1){
			for(var i=0; i<stars.length; i++)
				stars[i] = escape(decodeURIComponent(stars[i]));
			param = stars.join(".*");
		}

		if(start||end||stars.length>1)
			param = new RegExp((start ? "" : "^") + param + (end ? "" : "$"), "i");

		if(param && param.test)
			return param + ".test(value);";
		else
			return "\"" + decodeURIComponent(param).toUpperCase() + "\"===value.toUpperCase();";
	}
	var query = function (query, options, target){
		options = options || {};
		query = parseQuery(query, options.parameters);
		function t(){}
		t.prototype = exports.operators;
		var operators = new t;
		// inherit from exports.operators
		for (var i in options.operators) {
			if (options.operators.hasOwnProperty(i)) {
				operators[i] = options.operators[i];
			}
		}

		window.op = function(name){
			return operators[name]||exports.missingOperator(name);
		};
		//var parameters = options.parameters || [];
		//var js = "";
		function queryToJS(value){
			if(value && typeof value === "object" && value.constructor !== Date){
				if(value instanceof Array){
					return '[' + arr.map(value, queryToJS) + ']';
				}else{
					var jsOperator = exports.jsOperatorMap[value.name];
					if(jsOperator || /_*like/.test(value.name)){
						// item['foo.bar'] ==> (item && item.foo && item.foo.bar && ...)
						var path = value.args[0],
							target = value.args[1];
						var item;
						var escaped = [];

						if (typeof target == "undefined"){
							item = "item";
							target = path;
						} else {
							item = "item";
							path = path.split('.');
							for(var i = 0; i < path.length; i++){
								escaped.push(stringify(path[i]));
								item +="&&item[" + escaped.join("][") + ']';
							}
						}
						var condition;
						if(/_*like/.test(value.name)){
							var items = item.split("&&");
							item = items.slice(-1);

							condition = items.slice(0,-1);
							condition.push("(function(value){ return " +
								(value.name === "_like" ? "!" : "") +
								likeToString(value.args[1]) + "})(" + item + ")"
							);
							condition = condition.join("&&");
						}
						else {
							if(target.constructor === Date)
								condition = "(function(){ if(!(" + item + ")) var val = new Date(0); else { val = item[" + escaped.join("][") +
									"]; if(val.length !== undefined) val = new Date(val); } return val.valueOf()" +
									jsOperator + queryToJS(target)	+ "})()";
							else
								condition = item + jsOperator + queryToJS(target);
						}

						if (typeof Array.prototype.filter === 'function')
							return "(function(){return this.filter(function(item){return " + condition + "})})";
						else
							return "(function(){var arr = require('dojo/_base/array'); return arr.filter(this, function(item){return " + condition + "})})";
					}else{
						switch(value.name){
							case 'true': return true;
							case 'false': return false;
							case 'null': return null;
							case 'empty': return stringify("");
							case 'not': return value && value.args && value.args.length > 0 ? queryToJS(value.args[0]) : "";
							default:
								return (ie ? "" : "(") + "function(){return window.op('" + value.name + "').call(this" +
									(value && value.args && value.args.length > 0 ? (", " + arr.map(value.args, queryToJS).join(",")) : "") +
									")}" + (ie ? "" : ")");
						}
					}
				}
			}else{
				if(typeof value === "string")
					return stringify(value);
				if(value.constructor === Date)
					return value.valueOf();
				return value;
			}
		}
		var evaluator = new Function("target", "return " + queryToJS(query) + ".call(target);");
		return target ? evaluator(target) : evaluator;
	};

	var filter = function (condition) { //function (condition, not)
		var filter = function(property, second){
			if(typeof second == "undefined"){
				second = property;
				property = undefined;
			}
			//var args = arguments;
			var filtered = [];
			for(var i = 0, length = this.length; i < length; i++){
				var item = this[i];
				if(condition(evaluateProperty(item, property), second))
					filtered.push(item);
			}
			return filtered;
		};
		filter.condition = condition;
		return filter;
	};

	var evaluateProperty = function (object, property){
		if(property.indexOf('.') != -1){
			property = property.split('.');
			arr.forEach(property, function(part){
				object = object[decodeURIComponent(part)];
			});
			return object;
		}else if(typeof property == "undefined"){
			return object;
		}else{
			return object[decodeURIComponent(property)];
		}
	};

	exports.jsOperatorMap = {
		"eq" : "===",
		"ne" : "!==",
		"le" : "<=",
		"ge" : ">=",
		"lt" : "<",
		"gt" : ">"
	};
	exports.operators = {
		sort: function(){
			var terms = [];
			for(var i = 0; i < arguments.length; i++){
				var sortAttribute = arguments[i],
					firstChar = sortAttribute.charAt(0),
					term = {attribute: sortAttribute, ascending: true};
				if (firstChar == "-" || firstChar == "+") {
					if(firstChar == "-"){
						term.ascending = false;
					}
					term.attribute = term.attribute.substring(1);
				}
				term.getItem = function (item) { return item[term.attribute.replace('.', "\"][\"")]; };
				terms.push(term);
			}

			this.sort(function(a, b){
				for (var term, i = 0; term = terms[i]; i++)
					if(term.getItem(a) != term.getItem(b))
						return term.ascending == term.getItem(a) > term.getItem(b) ? 1 : -1;
				return 0;
			});
			return this;
		},
/*		match: filter(function(value, regex){	// Isn't implemented on server side
			return new RegExp(regex).test(value);
		}),		*/
		"in": filter(function(value, values){
			return values.indexOf(value) > -1;
		}),
		out: filter(function(value, values){
			return values.indexOf(value) == -1;
		}),
/*		contains: filter(function(array, value){	// Isn't implemented on server side
			if(typeof value == "function")
				return array instanceof Array && arr.some(array, function(v){
					return value.call([v]).length;
				});
			else
				return array instanceof Array && array.indexOf(value) > -1;
		}),	*/
/*		excludes: filter(function(array, value){	// Isn't implemented on server side
			if(typeof value == "function")
				return !arr.some(array, function(v){
					return value.call([v]).length;
				});
			else
				return array.indexOf(value) == -1;
		}),	*/
		or: function(){
			var items = [];
			for(var i = 0; i < arguments.length; i++)
				items = items.concat(arguments[i].call(this));
			return items;
		},
		and: function(){
			var items = this;
			for(var i = 0; i < arguments.length; i++)
				items = arguments[i].call(items);
			return items;
		},
/*		select: function(){		// Isn't implemented on server side
			var args = arguments,
				argc = arguments.length;
			return arr.map(this, function(object){
				var selected = {};
				for(var i = 0; i < argc; i++){
					var propertyName = args[i],
						value = evaluateProperty(object, propertyName);
					if(typeof value != "undefined"){
						selected[propertyName] = value;
					}
				}
				return selected;
			});
		},	*/
/*		unselect: function(){	// Isn't implemented on server side
			var args = arguments,
				argc = arguments.length;
			return arr.map(this, function(object){
				var selected = {};
				for (var i in object) if (object.hasOwnProperty(i)) {
					selected[i] = object[i];
				}
				for(var i = 0; i < argc; i++)
					delete selected[args[i]];
				return selected;
			});
		},	*/
/*		values: function(first){	// Isn't implemented on server side
			if(arguments.length == 1)
				return arr.map(this, function(object){
					return object[first];
				});
			var args = arguments,
				argc = arguments.length;
			return arr.map(this, function(object){
				var selected = [];
				if (argc === 0) {
					for(var i in object) if (object.hasOwnProperty(i)) {
						selected.push(object[i]);
					}
				} else {
					for(var i = 0; i < argc; i++){
						var propertyName = args[i];
						selected.push(object[propertyName]);
					}
				}
				return selected;
			});
		},	*/
		limit: function(start, limit, maxCount){
			var totalCount = this.length;
			start = start || 0;
			var sliced = this.slice(start, start + limit);
			if(maxCount){
				sliced.start = start;
				sliced.end = start + sliced.length - 1;
				sliced.totalCount = Math.min(totalCount, typeof maxCount === "number" ? maxCount : Infinity);
			}
			return sliced;
		},
/*		distinct: function(){	// Isn't implemented on server side
			var primitives = {},
				needCleaning = [],
				newResults = arr.filter(this, function(value){
				if(value && typeof value == "object"){
					if(!value.__found__){
						value.__found__ = function(){};// get ignored by JSON serialization
						needCleaning.push(value);
						return true;
					}
				}else{
					if(!primitives[value]){
						primitives[value] = true;
						return true;
					}
				}
			});
			arr.forEach(needCleaning, function(object){
				delete object.__found__;
			});
			return newResults;
		},	*/
/*		recurse: function(property){	// Isn't implemented on server side
			var newResults = [];
			function recurse(value){
				if(value instanceof Array){
					arr.forEach(value, recurse);
					return;
				}
				newResults.push(value);
				if(property){
					value = value[property];
					if(value && typeof value == "object"){
						recurse(value);
					}
				}else{
					for(var i in value){
						if(value[i] && typeof value[i] == "object"){
							recurse(value[i]);
						}
					}
				}
			}
			recurse(this);
			return newResults;
		},	*/
/*		aggregate: function(){	// Isn't implemented on server side
			var distinctives = [],
				aggregates = [];
			for(var i = 0; i < arguments.length; i++){
				var arg = arguments[i];
				if(typeof arg === "function"){
					 aggregates.push(arg);
				}else{
					distinctives.push(arg);
				}
			}
			var distinctObjects = {},
				dl = distinctives.length;
			arr.forEach(this, function(object){
				var key = "";
				for(var i = 0; i < dl;i++){
					key += '/' + object[distinctives[i]];
				}
				var arrayForKey = distinctObjects[key];
				if(!arrayForKey){
					arrayForKey = distinctObjects[key] = [];
				}
				arrayForKey.push(object);
			});
			var al = aggregates.length,
				newResults = [];
			for(var key in distinctObjects){
				var arrayForKey = distinctObjects[key],
					newObject = {};
				for(var i = 0; i < dl;i++){
					var property = distinctives[i];
					newObject[property] = arrayForKey[0][property];
				}
				for(var i = 0; i < al;i++){
					var aggregate = aggregates[i];
					newObject[i] = aggregate.call(arrayForKey);
				}
				newResults.push(newObject);
			}
			return newResults;
		},	*/
/*		between: filter(function(value, range){		// Isn't implemented on server side
			return value >= range[0] && value < range[1];
		}),
/*		sum: reducer(function(a, b){	// Isn't implemented on server side
			return a + b;
		}),	*/
/*		mean: function(property){	// Isn't implemented on server side
			return exports.operators.sum.call(this, property)/this.length;
		},	*/
/*		max: reducer(function(a, b){	// Isn't implemented on server side
			return Math.max(a, b);
		}),	*/
/*		min: reducer(function(a, b){	// Isn't implemented on server side
			return Math.min(a, b);
		}),	*/
		count: function(){
			return this.length;
		}/*,
		first: function(){	// Isn't implemented on server side
			return this[0];
		},	*/
/*		one: function(){	// Isn't implemented on server side
			if(this.length > 1)
				throw new TypeError("More than one object found");
			return this[0];
		}	*/
	};
/*	function reducer(func){ // Isn't implemented on server side
		return function(property){
			if(property)
				return arr.map.reduce(function(object){
					return object[property];
				}), func);
			else
				return this.reduce(func);
		}
	}	*/
	exports.filter = filter;
	exports.evaluateProperty = evaluateProperty;
/*	var conditionEvaluator = exports.conditionEvaluator = function(condition){
		var jsOperator = exports.jsOperatorMap[term.name];
		if(jsOperator)
			js += "(function(item){return item." + term[0] + jsOperator + "parameters[" + (index -1) + "][1];});";
		else
			js += "operators['" + term.name + "']";

		return eval(js);
	};	*/
	exports.executeQuery = function(query, options, target){
		return exports.query(query, options, target);
	};
	exports.query = query;
	exports.missingOperator = function(operator){
		throw new Error("Operator " + operator + " is not defined");
	};
/*
	function throwMaxIterations(){
		throw new Error("Query has taken too much computation, and the user is not allowed to execute resource-intense queries. Increase maxIterations in your config file to allow longer running non-indexed queries to be processed.");
	}
*/
	exports.maxIterations = 10000;
	return exports;
});
