define([
        "aps/i18n"
], function (
    _
) {
    var timeZones = [
        {
            "value": "Dateline Standard Time",
            "label": _("(UTC-12:00) International Date Line West")
        },
        {
            "value": "UTC-11",
            "label": _("(UTC-11:00) Coordinated Universal Time-11")
        },
        {
            "value": "Samoa Standard Time",
            "label": _("(UTC-11:00) Samoa")
        },
        {
            "value": "Hawaiian Standard Time",
            "label": _("(UTC-10:00) Hawaii")
        },
        {
            "value": "Alaskan Standard Time",
            "label": _("(UTC-09:00) Alaska")
        },
        {
            "value": "Pacific Standard Time (Mexico)",
            "label": _("(UTC-08:00) Baja California")
        },
        {
            "value": "Pacific Standard Time",
            "label": _("(UTC-08:00) Pacific Time (US & Canada)")
        },
        {
            "value": "US Mountain Standard Time",
            "label": _("(UTC-07:00) Arizona")
        },
        {
            "value": "Mountain Standard Time (Mexico)",
            "label": _("(UTC-07:00) Chihuahua, La Paz, Mazatlan")
        },
        {
            "value": "Mountain Standard Time",
            "label": _("(UTC-07:00) Mountain Time (US & Canada)")
        },
        {
            "value": "Central America Standard Time",
            "label": _("(UTC-06:00) Central America")
        },
        {
            "value": "Central Standard Time",
            "label": _("(UTC-06:00) Central Time (US & Canada)")
        },
        {
            "value": "Central Standard Time (Mexico)",
            "label": _("(UTC-06:00) Guadalajara, Mexico City, Monterrey")
        },
        {
            "value": "Canada Central Standard Time",
            "label": _("(UTC-06:00) Saskatchewan")
        },
        {
            "value": "SA Pacific Standard Time",
            "label": _("(UTC-05:00) Bogota, Lima, Quito")
        },
        {
            "value": "Eastern Standard Time",
            "label": _("(UTC-05:00) Eastern Time (US & Canada)")
        },
        {
            "value": "US Eastern Standard Time",
            "label": _("(UTC-05:00) Indiana (East)")
        },
        {
            "value": "Venezuela Standard Time",
            "label": _("(UTC-04:30) Caracas")
        },
        {
            "value": "Paraguay Standard Time",
            "label": _("(UTC-04:00) Asuncion")
        },
        {
            "value": "Atlantic Standard Time",
            "label": _("(UTC-04:00) Atlantic Time (Canada)")
        },
        {
            "value": "Central Brazilian Standard Time",
            "label": _("(UTC-04:00) Cuiaba")
        },
        {
            "value": "SA Western Standard Time",
            "label": _("(UTC-04:00) Georgetown, La Paz, Manaus, San Juan")
        },
        {
            "value": "Pacific SA Standard Time",
            "label": _("(UTC-04:00) Santiago")
        },
        {
            "value": "Newfoundland Standard Time",
            "label": _("(UTC-03:30) Newfoundland")
        },
        {
            "value": "E. South America Standard Time",
            "label": _("(UTC-03:00) Brasilia")
        },
        {
            "value": "Argentina Standard Time",
            "label": _("(UTC-03:00) Buenos Aires")
        },
        {
            "value": "SA Eastern Standard Time",
            "label": _("(UTC-03:00) Cayenne, Fortaleza")
        },
        {
            "value": "Greenland Standard Time",
            "label": _("(UTC-03:00) Greenland")
        },
        {
            "value": "Montevideo Standard Time",
            "label": _("(UTC-03:00) Montevideo")
        },
        {
            "value": "UTC-02",
            "label": _("(UTC-02:00) Coordinated Universal Time-02")
        },
        {
            "value": "Mid-Atlantic Standard Time",
            "label": _("(UTC-02:00) Mid-Atlantic")
        },
        {
            "value": "Azores Standard Time",
            "label": _("(UTC-01:00) Azores")
        },
        {
            "value": "Cape Verde Standard Time",
            "label": _("(UTC-01:00) Cape Verde Is.")
        },
        {
            "value": "Morocco Standard Time",
            "label": _("(UTC) Casablanca")
        },
        {
            "value": "UTC",
            "label": _("(UTC) Coordinated Universal Time")
        },
        {
            "value": "GMT Standard Time",
            "label": _("(UTC) Dublin, Edinburgh, Lisbon, London")
        },
        {
            "value": "Greenwich Standard Time",
            "label": _("(UTC) Monrovia, Reykjavik")
        },
        {
            "value": "W. Europe Standard Time",
            "label": _("(UTC+01:00) Amsterdam, Berlin, Bern, Rome, Stockholm, Vienna")
        },
        {
            "value": "Central Europe Standard Time",
            "label": _("(UTC+01:00) Belgrade, Bratislava, Budapest, Ljubljana, Prague")
        },
        {
            "value": "Romance Standard Time",
            "label": _("(UTC+01:00) Brussels, Copenhagen, Madrid, Paris")
        },
        {
            "value": "Central European Standard Time",
            "label": _("(UTC+01:00) Sarajevo, Skopje, Warsaw, Zagreb")
        },
        {
            "value": "W. Central Africa Standard Time",
            "label": _("(UTC+01:00) West Central Africa")
        },
        {
            "value": "Namibia Standard Time",
            "label": _("(UTC+01:00) Windhoek")
        },
        {
            "value": "Jordan Standard Time",
            "label": _("(UTC+02:00) Amman")
        },
        {
            "value": "GTB Standard Time",
            "label": _("(UTC+02:00) Athens, Bucharest")
        },
        {
            "value": "Middle East Standard Time",
            "label": _("(UTC+02:00) Beirut")
        },
        {
            "value": "Egypt Standard Time",
            "label": _("(UTC+02:00) Cairo")
        },
        {
            "value": "Syria Standard Time",
            "label": _("(UTC+02:00) Damascus")
        },
        {
            "value": "South Africa Standard Time",
            "label": _("(UTC+02:00) Harare, Pretoria")
        },
        {
            "value": "FLE Standard Time",
            "label": _("(UTC+02:00) Helsinki, Kyiv, Riga, Sofia, Tallinn, Vilnius")
        },
        {
            "value": "Turkey Standard Time",
            "label": _("(UTC+02:00) Istanbul")
        },
        {
            "value": "Israel Standard Time",
            "label": _("(UTC+02:00) Jerusalem")
        },
        {
            "value": "E. Europe Standard Time",
            "label": _("(UTC+02:00) Minsk")
        },
        {
            "value": "Arabic Standard Time",
            "label": _("(UTC+03:00) Baghdad")
        },
        {
            "value": "Kaliningrad Standard Time",
            "label": _("(UTC+03:00) Kaliningrad")
        },
        {
            "value": "Arab Standard Time",
            "label": _("(UTC+03:00) Kuwait, Riyadh")
        },
        {
            "value": "E. Africa Standard Time",
            "label": _("(UTC+03:00) Nairobi")
        },
        {
            "value": "Iran Standard Time",
            "label": _("(UTC+03:30) Tehran")
        },
        {
            "value": "Arabian Standard Time",
            "label": _("(UTC+04:00) Abu Dhabi, Muscat")
        },
        {
            "value": "Azerbaijan Standard Time",
            "label": _("(UTC+04:00) Baku")
        },
        {
            "value": "Russian Standard Time",
            "label": _("(UTC+04:00) Moscow, St. Petersburg, Volgograd")
        },
        {
            "value": "Mauritius Standard Time",
            "label": _("(UTC+04:00) Port Louis")
        },
        {
            "value": "Georgian Standard Time",
            "label": _("(UTC+04:00) Tbilisi")
        },
        {
            "value": "Caucasus Standard Time",
            "label": _("(UTC+04:00) Yerevan")
        },
        {
            "value": "Afghanistan Standard Time",
            "label": _("(UTC+04:30) Kabul")
        },
        {
            "value": "Pakistan Standard Time",
            "label": _("(UTC+05:00) Islamabad, Karachi")
        },
        {
            "value": "West Asia Standard Time",
            "label": _("(UTC+05:00) Tashkent")
        },
        {
            "value": "India Standard Time",
            "label": _("(UTC+05:30) Chennai, Kolkata, Mumbai, New Delhi")
        },
        {
            "value": "Sri Lanka Standard Time",
            "label": _("(UTC+05:30) Sri Jayawardenepura")
        },
        {
            "value": "Nepal Standard Time",
            "label": _("(UTC+05:45) Kathmandu")
        },
        {
            "value": "Central Asia Standard Time",
            "label": _("(UTC+06:00) Astana")
        },
        {
            "value": "Bangladesh Standard Time",
            "label": _("(UTC+06:00) Dhaka")
        },
        {
            "value": "Ekaterinburg Standard Time",
            "label": _("(UTC+06:00) Ekaterinburg")
        },
        {
            "value": "Myanmar Standard Time",
            "label": _("(UTC+06:30) Yangon (Rangoon)")
        },
        {
            "value": "SE Asia Standard Time",
            "label": _("(UTC+07:00) Bangkok, Hanoi, Jakarta")
        },
        {
            "value": "N. Central Asia Standard Time",
            "label": _("(UTC+07:00) Novosibirsk")
        },
        {
            "value": "China Standard Time",
            "label": _("(UTC+08:00) Beijing, Chongqing, Hong Kong, Urumqi")
        },
        {
            "value": "North Asia Standard Time",
            "label": _("(UTC+08:00) Krasnoyarsk")
        },
        {
            "value": "Singapore Standard Time",
            "label": _("(UTC+08:00) Kuala Lumpur, Singapore")
        },
        {
            "value": "W. Australia Standard Time",
            "label": _("(UTC+08:00) Perth")
        },
        {
            "value": "Taipei Standard Time",
            "label": _("(UTC+08:00) Taipei")
        },
        {
            "value": "Ulaanbaatar Standard Time",
            "label": _("(UTC+08:00) Ulaanbaatar")
        },
        {
            "value": "North Asia East Standard Time",
            "label": _("(UTC+09:00) Irkutsk")
        },
        {
            "value": "Tokyo Standard Time",
            "label": _("(UTC+09:00) Osaka, Sapporo, Tokyo")
        },
        {
            "value": "Korea Standard Time",
            "label": _("(UTC+09:00) Seoul")
        },
        {
            "value": "Cen. Australia Standard Time",
            "label": _("(UTC+09:30) Adelaide")
        },
        {
            "value": "AUS Central Standard Time",
            "label": _("(UTC+09:30) Darwin")
        },
        {
            "value": "E. Australia Standard Time",
            "label": _("(UTC+10:00) Brisbane")
        },
        {
            "value": "AUS Eastern Standard Time",
            "label": _("(UTC+10:00) Canberra, Melbourne, Sydney")
        },
        {
            "value": "West Pacific Standard Time",
            "label": _("(UTC+10:00) Guam, Port Moresby")
        },
        {
            "value": "Tasmania Standard Time",
            "label": _("(UTC+10:00) Hobart")
        },
        {
            "value": "Yakutsk Standard Time",
            "label": _("(UTC+10:00) Yakutsk")
        },
        {
            "value": "Central Pacific Standard Time",
            "label": _("(UTC+11:00) Solomon Is., New Caledonia")
        },
        {
            "value": "Vladivostok Standard Time",
            "label": _("(UTC+11:00) Vladivostok")
        },
        {
            "value": "New Zealand Standard Time",
            "label": _("(UTC+12:00) Auckland, Wellington")
        },
        {
            "value": "UTC+12",
            "label": _("(UTC+12:00) Coordinated Universal Time+12")
        },
        {
            "value": "Fiji Standard Time",
            "label": _("(UTC+12:00) Fiji")
        },
        {
            "value": "Magadan Standard Time",
            "label": _("(UTC+12:00) Magadan")
        },
        {
            "value": "Kamchatka Standard Time",
            "label": _("(UTC+12:00) Petropavlovsk-Kamchatsky - Old")
        },
        {
            "value": "Tonga Standard Time",
            "label": _("(UTC+13:00) Nuku'alofa")
        }
    ];

    return timeZones;
});